#!/bin/bash						

#########################################################
# quick and dirty shell script that backup a	 	#
# Cacti instance.					#
# ---------------------------------------------------	#
# Author: Zach Hilliard					#
# Date 9/28/2009					#
# Support: umm, email me :) zhilliard@terremark.com	#
#########################################################

# lets start callin out Vars

cdate="$(date '+%H-%M')"
folder_date="$(date '+%Y-%m-%d')"
backupdir="/u02/backup/cacti/${folder_date}"
latest_dump_filename="${backupdir}/../db-sql-current.sql"
backup_filename="${backupdir}/db-${cdate}.sql"


# Check to see if backup dir exists.

test -d ${backupdir} || mkdir -p ${backupdir}


# Create the file for the dump (as it _HAS_ to be there and cannot be created via mysqldump

touch ${backup_filename}

# Create a dump of the Cacti db.

mysqldump cacti > ${backup_filename}

# Tar up cacti's webdir

tar -C /var/www/ -cvf ${backupdir}/www-${cdate}.tar html/cacti > /dev/null 2>&1

# Make a copy of the my.cnf and move it to the backupdir
cp /etc/my.cnf ${backupdir}/my-${cdate}.cnf

# Remove previous link
if [ -h ${latest_dump_filename} ];
then
	unlink ${latest_dump_filename}
fi
# Create link for restore script

ln -s ${backup_filename} ${latest_dump_filename} && echo "Backup Complete"
