#!/bin/bash						

#########################################################
# quick and dirty shell script that restores a	 	#
# Cacti instance.					#
# ---------------------------------------------------	#
# Author: Zach Hilliard					#
# Date 9/28/2009					#
# Support: umm, email me :) zhilliard@terremark.com	#
#########################################################

# Base var's
cdate="$(date '+%H-%M')"
backupdir="/u02/backup/cacti"
latest_dump_filename="db-sql-current.sql"


sqlsocket=`grep socket /etc/my.cnf | awk -F = '{ print $2 } '`

if [ `id -u` == "0" ];
then
	echo "Good we are running as root"
else
	echo "Please move to root and rerun me"; exit
fi



# Check to make sure MySQL is up, I know this is more than likely not required but... just incase

count=0;
echo -n "Checking MySQL"

while [ ! -S "${sqlsocket}" ]; do
	sleep 1;
	echo -n "."
	count=$((count+1));
	[ $count -gt 5 ] && { echo " Timed out waiting for MySQL, please verify that you can start it "; exit; }
done

# Startig the main case statment to select which backup the want to use
echo "				"
echo -n "Found MySQL!!"
echo "				"
echo "Starting restore"
echo "				"
echo "Would you like to restore from the most recent backup? or older backup?"
echo "1) Current"
echo "2) Other"
echo "---------------"
read backupselection

case $backupselection in
1)
	echo "Using Current backup ${latest_dump_filename}"
	export usebackup=${latest_dump_filename}
	export currentinuse=1
;;
2)
	echo "Please select backup date in year-month-date format (Example 2009-09-28)"
	echo "---------------"

read backselectdate

# After we have read the variable in lets quantify it and see if it exists.

if [ -d ${backupdir}/${backselectdate} ];
then
	export usebackup=$backselectdate
else
	echo "No backup with that date found"
	echo "					"
	echo "Please select from the following available dates"
	ls ${backupdir} | grep -e [[:digit:]]
	echo "---------------"
	read backupselectdate

# Now that we have verifed that it does or in a case maybe dosent exist
# And we bail as I gave you a list, and we couldnt make a decent selection out of it

if [ -d ${backupdir}/${backupselectdate} ]; 
then
        export usebackup=$backupselectdate
else
        echo "Im Sorry Dave... you have selected an invalid backup date.. Goodbye"
exit 1
fi
fi

echo "Would you like to overwrite the my.cnf with the backups my.cnf?"
echo "---------------"
read mycnfresponce

if [ ${mycnfresponce} == "yes" ];
then
	diff /etc/my.cnf ${backupdir}/${usebackup}/my-*.cnf > /dev/null
	if [ $? == 0 ];
	then
		echo "Files where the same moving on....."
	else
		cp ${backupdir}/${usebackup}/my-*.cnf /etc/my.cnf || echo "copied failed"
	fi
else
echo "You have selected to _NOT_ replace the /etc/my.cnf"
fi
;;
esac

# Where do we want to restore this DB to? its default db name (cacti) or a whole new DB.

echo "Select database name"
echo "				"
echo "1) Default (cacti)"
echo "2) Other"
echo "---------------"
read userdblocation

case $userdblocation in
1)
	echo "Using default db location"; export dblocation="cacti"

;;

2)
	echo "What would you like the db to be called"
	echo "---------------"
	read dblocation
export dblocation
;;
esac


# An attempt at some damage control... dont bork your shit.

echo "Your selected values are"
echo "Backup file is ${usebackup}"
echo "Database restore location is ${dblocation}"
echo "			"
echo "Are you sure you want to continue?(yes/no)"
read responce

sanresponce=`echo $responce | tr "[:upper:]" "[:lower:]"`

if [ ${sanresponce} == "yes" ];
then

# We will see if the db exists
dblist=`mysql < ${backupdir}/scripts/mysql/show.sql`

if [ ${dblocation} != "cacti" ];
then
	present=`echo ${dblist} | grep -c ${dblocation}`

	if [ $present == "0" ];
		then
			mysqladmin create ${dblocation}
			
			# Since we created the db we will need to allow cactiuser access
			# *** NOTE *** your db user _MUST_ have create access on the db
			# GRANT CREATE on *.* to yourdbuser@localhost;
			#
			# Since we had to make the db we will have to get the user to elevate
			# their priviliages to modifiy the db

			echo "Please enter MySQL's root pw so we can grant privliages to the cactiuser"
			read -s rootpw
			
			# lets 0 out the grant.sql so we dont have extra junk
			cat /dev/null > ${backupdir}/scripts/mysql/grant.sql
		
			cat <<- GRANT >> ${backupdir}/scripts/mysql/grant.sql
			grant all on ${dblocation}.* to cactiuser@localhost;
			GRANT
			
			mysql -u root -p${rootpw} ${dblocation} < "${backupdir}/scripts/mysql/grant.sql" && echo "Grant access enabled on ${dblocation} for cactiuser"
			else
			echo "DB already exists"
	fi
else
	echo "Restoring over default instance"

	fi
else
	echo "Please dont restore over cacti"; exit 4
fi
	## Lets start making some fancy stuff

	rotdash2()
{
p=$1
while [ -d /proc/$p ]
do
echo -en '\E[32;40m/^H' ; sleep .05
echo -en '\E[32;40m-^H' ; sleep .05
echo -en '\E[32;40m\^H' ; sleep .05
echo -en '\E[32;40m|^H' ; sleep .05
echo -en '\E[32;42mS' ; tput sgr0 ; sleep .2
done
}

echo "Starting DB restore"
echo "			"
mysql ${dblocation} < ${backupdir}/${usebackup}&
echo "					"
rotdash2 $! || echo "Something very bad has occured, the restore process has failed please escalate outage to ASE"
echo "					"
## Now that we have the Database back in place the hardpart is over.... now lets just restore the webdir and go home!

echo "Do you want to restore the webdir? (It is recommended to do so as this contains the RAA files)"
echo "					"
read webresponce

sanwresponce=`echo $webresponce | tr "[:upper:]" "[:lower:]"`

if [ ${sanwresponce} == "yes" ];
then

tar -C /var/www/ -xvf ${backupdir}/${usebackup} || echo "Webdir Restore Failed" && echo "Webdir restore Complete"

# Webdir has been put in its place we should be good to go!

echo "		"
echo "What is the url for your cacti instance?"
echo "Example http://192.168.1.200/cacti"
read cactiurl

lynx --dump $cactiurl


test ${urlresponce} = "0" && echo "I was unable to access the URL listed" || echo "Found Cacti, you should be good to go"

# We are all done here...

